// closure to avoid namespace collision
(function(){
	tinymce.create('tinymce.plugins.customindexshortcode', {
		createControl : function(id, controlManager) {
			if (id == 'customindexshortcode_button') {
				var button = controlManager.createButton('customindexshortcode_button', {
					title : 'Custom Index Shortcode', 
					image : '../wp-content/plugins/custom-index-shortcode/tree1.jpg',  
					onclick : function() {
						var width = jQuery(window).width(), H = jQuery(window).height(), W = ( 720 < width ) ? 720 : width;
						W = W - 80;
						H = H - 84;
						tb_show( 'Custom Index Shortcode', '#TB_inline?width=' + W + '&height=' + H + '&inlineId=customindexshortcode-form' );
					}
				});
				return button;
			}
			return null;
		}
	});
	
	tinymce.PluginManager.add('customindexshortcode', tinymce.plugins.customindexshortcode);
	
	jQuery(function(){
		var form = jQuery('<div id="customindexshortcode-form"><table id="customindexshortcode-table" class="form-table">\
			<tr>\
				<th><label for="customindexshortcode-title">Title</label></th>\
				<td><input type="text" name="title" id="customindexshortcode-title" value="" /><br />\
				<small>specify the title of the list. leave blank for no title.</small></td>\
			</tr>\
			<tr>\
				<th><label for="customindexshortcode-id">Parent Page ID</label></th>\
				<td><input type="text" name="id" id="customindexshortcode-id" value="" /><br />\
				<small>specify the parent page ID. leave blank to use the current page.</small></td>\
			</tr>\
			<tr>\
				<th><label for="customindexshortcode-depth">Depth</label></th>\
				<td><select name="depth" id="customindexshortcode-depth" value="">\
				<option value="0">0</option>\
				<option value="1">1</option>\
				<option value="2">2</option>\
				<option value="3">3</option>\
				</select><br />\
				<small>choose how many generations of children will be shown.</small></td>\
			</tr>\
			<tr>\
				<th><label for="customindexshortcode-orderby">Order By</label></th>\
				<td><select name="orderby" id="customindexshortcode-orderby" value="">\
				<option value="post_title">page title</option>\
				<option value="menu_order">menu order</option>\
				<option value="post_date">creation time</option>\
				<option value="post_modified">last modification time</option>\
				<option value="ID">ID</option>\
				<option value="post_author">author</option>\
				<option value="rand">random</option>\
				</select><br />\
				<small>choose how you want the list to be sorted.</small></td>\
			</tr>\
			<tr>\
				<th><label for="customindexshortcode-order">Order</label></th>\
				<td><select name="order" id="customindexshortcode-order" value="">\
				<option value="ASC">ASC</option>\
				<option value="DESC">DESC</option>\
				</select><br />\
				<small>choose the order.</small></td>\
			</tr>\
			<tr>\
				<th><label for="customindexshortcode-list">List</label></th>\
				<td><select name="list" id="customindexshortcode-list" value="">\
				<option value="ordered">ordered</option>\
				<option value="unordered">unordered</option>\
				</select><br />\
				<small>choose the kind of list you want the elements to be shown in.</small></td>\
			</tr>\
			</table>\
			<p class="submit">\
				<input type="button" id="customindexshortcode-submit" class="button-primary" value="Insert Index" name="submit" />\
			</p>\
		</div>');
		
		var table = form.find('table');
		form.appendTo('body').hide();
		
		form.find('#customindexshortcode-submit').click(function(){
			var options = {
				'title'      : '',
				'id'         : '',
				'depth'      : '',
				'orderby'    : '',
				'order'      : '',
				'list'	     : '' 
				};
			var shortcode = '[custom-index';
			
			for( var index in options) {
				var value = table.find('#customindexshortcode-' + index).val();
				
				if ( value !== options[index] )
					shortcode += ' ' + index + '="' + value + '"';
			}
			
			shortcode += ']';
			
			tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
			
			tb_remove();
		});
	});
})()