<?php
/*
Plugin Name: Custom Index Shortcode
Plugin URI: 
Description: create customizable lists of pages using a simple shortcode
Author: Federico Azzario
Version: 1.0
Author URI: www.teuteca.com/ibis
*/

add_shortcode("custom-index", "custom_index_shortcode");

function custom_index_shortcode($attributes){
	
	if(isset($attributes['id']) && is_numeric($attributes['id'])){
		//id specified by shortcode attribute
		$parent = $attributes['id'];
	}else{
		//get the id of the current article that is calling the shortcode
		$parent = get_the_ID();
	}
	
	$i = 0;
	//if(!isset($attributes['depth'])) $parentnodepth = $parent;
	//else $parentnodepth = '-1';
	$args = array(
		'parent' => $parent, //$parentnodepth,
		'child_of' => $parent,
		'post_type' => 'page',
		'hierarchical' => 0
	);
	if(isset($attributes['title'])) echo "<span style='font-size:1.5em;font-weight:bold;'>".$attributes['title']."</span>";
	if(isset($attributes['list']) && $attributes['list']=='unordered') echo"<ul>";
	if(isset($attributes['list']) && $attributes['list']=='ordered') echo"<ol>";
	
	
	if(isset($attributes['order'])) $args['sort_order'] = $attributes['order'];
	if(isset($attributes['orderby'])) $args['sort_column'] = $attributes['orderby'];
	
	$mypages = get_pages($args);
	
	foreach( $mypages as $page ) {		

	?>
		<li><a href="<?php echo get_page_link( $page->ID ); ?>"><?php echo $page->post_title; ?></a></li>
		
		<?php
		
		if(isset($attributes['depth']) && $attributes['depth']>=1) {
		
		$childrenargs = array(
		'parent' => $page->ID,
		'child_of' => $page->ID,
		'post_type' => 'page',
		'hierarchical' => 0
		);
		
		if(isset($attributes['list']) && $attributes['list']=='unordered') echo"<ul>";
		if(isset($attributes['list']) && $attributes['list']=='ordered') echo"<ol>";
		
		$mychildren = get_pages($childrenargs);
	
		foreach( $mychildren as $child ) {		

		?>
			<li><a href="<?php echo get_page_link( $child->ID ); ?>"><?php echo $child->post_title; ?></a></li>
		
		<?php
		
			if(isset($attributes['depth']) && $attributes['depth']>=2) {
		
			$granchildrenargs = array(
			'parent' => $child->ID,
			'child_of' => $child->ID,
			'post_type' => 'page',
			'hierarchical' => 0
			);
		
			if(isset($attributes['list']) && $attributes['list']=='unordered') echo"<ul>";
			if(isset($attributes['list']) && $attributes['list']=='ordered') echo"<ol>";
		
			$mygranchildren = get_pages($granchildrenargs);
	
			foreach( $mygranchildren as $granchild ) {		

			?>
				<li><a href="<?php echo get_page_link( $granchild->ID ); ?>"><?php echo $granchild->post_title; ?></a></li>
		
			<?php
		
				if(isset($attributes['depth']) && $attributes['depth']>=3) {
			
				$grangranchildrenargs = array(
				'parent' => $granchild->ID,
				'child_of' => $granchild->ID,
				'post_type' => 'page',
				'hierarchical' => 0
				);
		
				if(isset($attributes['list']) && $attributes['list']=='unordered') echo"<ul>";
				if(isset($attributes['list']) && $attributes['list']=='ordered') echo"<ol>";
		
				$mygrangranchildren = get_pages($grangranchildrenargs);
	
				foreach( $mygrangranchildren as $grangranchild ) {		

				?>
					<li><a href="<?php echo get_page_link( $grangranchild->ID ); ?>"><?php echo $grangranchild->post_title; ?></a></li>
		
				<?php
		
		
				}
			
				if(isset($attributes['list']) && $attributes['list']=='unordered') echo"</ul>";
				if(isset($attributes['list']) && $attributes['list']=='ordered') echo"</ol>";
				}
			}
			
			if(isset($attributes['list']) && $attributes['list']=='unordered') echo"</ul>";
			if(isset($attributes['list']) && $attributes['list']=='ordered') echo"</ol>";
			}
		}
			
		if(isset($attributes['list']) && $attributes['list']=='unordered') echo"</ul>";
		if(isset($attributes['list']) && $attributes['list']=='ordered') echo"</ol>";
		}
	}	
	if(isset($attributes['list']) && $attributes['list']=='unordered') echo"</ul>";
	if(isset($attributes['list']) && $attributes['list']=='ordered') echo"</ol>";
}

//**********************************************************************************************************************************

// ADDING QUICKTAG TO HTML EDITOR

if( !function_exists('_add_my_quicktags') ){
  function add_custom_index_quicktags(){
?>

    <script type="text/javascript">  
    /**
     * Add custom Quicktag buttons to the WordPress editor 
     * for ver. 3.3 and above only
     * Params for the addButton function are:
     *  - Button HTML ID (required)
     *  - Opening Tag (required)
     *  - Closing Tag (required)
     *  - Access key, accesskey="" attribute for the button (optional)
     *  - Title, title="" attribute (optional)
     *  - Priority/position on bar, 1-9 = first, 11-19 = second,
     *    21-29 = third, etc. (optional)
     */
    QTags.addButton( 'custom-index', 'custom-index', '[custom-index]','','','Custom Index Shortcode',999);  
    
    </script>

<?php
  }
  add_action('admin_print_footer_scripts',  'add_custom_index_quicktags');
}

//*********************************************************************************************************************************

// ADDING TinyMCE BUTTON

if ( ! defined( 'ABSPATH' ) )
	die( "Can't load this file directly" );

class CustomIndexShortcode
{
	function __construct() {
		add_action( 'admin_init', array( $this, 'action_admin_init' ) );
	}
	
	function action_admin_init() {
		if ( current_user_can( 'edit_posts' ) && current_user_can( 'edit_pages' ) ) {
			add_filter( 'mce_buttons', array( $this, 'filter_mce_button' ) );
			add_filter( 'mce_external_plugins', array( $this, 'filter_mce_plugin' ) );
		}
	}
	
	function filter_mce_button( $buttons ) {
		array_push( $buttons, '|', 'customindexshortcode_button' );
		return $buttons;
	}
	
	function filter_mce_plugin( $plugins ) {
		$plugins['customindexshortcode'] = plugin_dir_url( __FILE__ ) . 'customindexshortcode_plugin.js';
		return $plugins;
	}
}

$mygallery = new CustomIndexShortcode();
?>